=== lrc/CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,22 @@
 INCLUDE(CMakePackageConfigHelpers)
 INCLUDE(GenerateExportHeader)
 
-ADD_DEFINITIONS(
-   ${QT_DEFINITIONS}
-   -fexceptions
-   -O2
-)
+string(SUBSTRING ${CMAKE_GENERATOR} 0 14 CMAKE_GENERATOR_SHORT)
+if(CMAKE_GENERATOR_SHORT MATCHES "Visual Studio ")
+    message(STATUS "Generating VS project")
+    set(CMAKE_CXX_COMPILER_ID "MSVC")
+    set(ENABLE_TEST false)
+    set(ENABLE_STATIC true)
+    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Zi /W0")
+endif()
+
+if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
+    ADD_DEFINITIONS(
+       ${QT_DEFINITIONS}
+       -fexceptions
+       -O2
+    )
+endif()
 
 # Options
 set(CHK_FREEABLE_BEFORE_ERASE_ACCOUNT_DESCRIPTION
@@ -83,39 +94,41 @@
   SET(ENABLE_LIBWRAP true) # because mocks use the same interface present in src/qtwrapper
 ENDIF()
 
+if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
 # Enable some useful warnings
-ADD_DEFINITIONS(
-   -Wall
-   -Wextra
-   -Wmissing-declarations
-   -Wmissing-noreturn
-   -Wpointer-arith
-   -Wcast-align
-   -Wwrite-strings
-   -Wformat-nonliteral
-   -Wformat-security
-   -Wswitch-enum
-   -Winit-self
-   -Wmissing-include-dirs
-   -Wundef
-   -Wmissing-format-attribute
-   -Wno-reorder
-   -Wunused
-   -Wuninitialized
-   -Woverloaded-virtual
-   -Wunused-value
-   -pedantic
-   -Wnonnull
-   -Wsequence-point
-   #-Wsystem-headers
-   -Wsizeof-pointer-memaccess
-   #-Wuseless-cast
-   -Wvarargs
-
-   #See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=55578
-   -Wno-unused-function
-   -Wno-attributes
-)
+    ADD_DEFINITIONS(
+       -Wall
+       -Wextra
+       -Wmissing-declarations
+       -Wmissing-noreturn
+       -Wpointer-arith
+       -Wcast-align
+       -Wwrite-strings
+       -Wformat-nonliteral
+       -Wformat-security
+       -Wswitch-enum
+       -Winit-self
+       -Wmissing-include-dirs
+       -Wundef
+       -Wmissing-format-attribute
+       -Wno-reorder
+       -Wunused
+       -Wuninitialized
+       -Woverloaded-virtual
+       -Wunused-value
+       -pedantic
+       -Wnonnull
+       -Wsequence-point
+       #-Wsystem-headers
+       -Wsizeof-pointer-memaccess
+       #-Wuseless-cast
+       -Wvarargs
+
+       #See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=55578
+       -Wno-unused-function
+       -Wno-attributes
+    )
+endif()
 
 #Add more warnings for compilers that support it. I used this command:
 #curl https://gcc.gnu.org/onlinedocs/gcc-4.9.2/gcc/Warning-Options.html | \
@@ -198,7 +211,9 @@
 
    ADD_SUBDIRECTORY(${CMAKE_SOURCE_DIR}/src/qtwrapper)
    ADD_DEFINITIONS(-DENABLE_LIBWRAP=true) # Use native calls (no dbus)
-   ADD_DEFINITIONS(-Wno-unknown-pragmas)
+   if (NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
+      ADD_DEFINITIONS(-Wno-unknown-pragmas)
+   endif()
    SET(ENABLE_QT5 true) # Use Qt5
    MESSAGE(STATUS "Compiling with qtwrapper enabled, Qt5 enabled.")
 
@@ -235,16 +250,18 @@
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/src)
 INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR})
 
-# Build dbus api
-IF(DEFINED RING_XML_INTERFACES_DIR)
-    SET (dbus_xml_introspecs_path ${RING_XML_INTERFACES_DIR})
-ELSEIF(EXISTS "${RING_BUILD_DIR}/../bin/dbus")
-    SET (dbus_xml_introspecs_path ${RING_BUILD_DIR}/../bin/dbus)
-ELSE()
-    SET (dbus_xml_introspecs_path ${CMAKE_INSTALL_PREFIX}/share/dbus-1/interfaces)
-ENDIF()
-
-MESSAGE(STATUS "Using Ring DBus-XML interfaces in ${dbus_xml_introspecs_path}")
+IF(NOT (CMAKE_CXX_COMPILER_ID MATCHES "MSVC"))
+    # Build dbus api
+    IF(DEFINED RING_XML_INTERFACES_DIR)
+        SET (dbus_xml_introspecs_path ${RING_XML_INTERFACES_DIR})
+    ELSEIF(EXISTS "${RING_BUILD_DIR}/../bin/dbus")
+        SET (dbus_xml_introspecs_path ${RING_BUILD_DIR}/../bin/dbus)
+    ELSE()
+        SET (dbus_xml_introspecs_path ${CMAKE_INSTALL_PREFIX}/share/dbus-1/interfaces)
+    ENDIF()
+
+    MESSAGE(STATUS "Using Ring DBus-XML interfaces in ${dbus_xml_introspecs_path}")
+ENDIF()
 
 #File to compile
 SET( libringclient_LIB_SRCS
@@ -419,30 +436,3 @@
   src/credentialmodel.h
   src/categorizedcontactmodel.h
   src/useractionmodel.h
-  src/presencestatusmodel.h
-  src/contactmethod.h
-  src/phonedirectorymodel.h
-  src/historytimecategorymodel.h
-  src/numbercategorymodel.h
-  src/keyexchangemodel.h
-  src/codecmodel.h
-  src/tlsmethodmodel.h
-  src/protocolmodel.h
-  src/numbercompletionmodel.h
-  src/profilemodel.h
-  src/numbercategory.h
-  src/ringtonemodel.h
-  src/localrecordingcollection.h
-  src/localbookmarkcollection.h
-  src/localringtonecollection.h
-  src/localmacrocollection.h
-  src/localhistorycollection.h
-  src/localprofilecollection.h
-  src/localtextrecordingcollection.h
-  src/peerprofilecollection.h
-  src/lastusednumbermodel.h
-  src/securityevaluationmodel.h
-  src/certificate.h
-  src/personmodel.h
-  src/transitionalpersonbackend.h
-  src/collectionmodel.h
